<?php
//  Copyright (C) 2004-2004  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

if ($a->getUsername() == $admin_name) {
	$smarty->assign('show_admin_links', 'true');
	$backup = $_GET['backup'];
	$type = $_GET['type'];
	if ($backup == "yes") {
		/* Journalness Backup script is a modified
		* version of the phpBB2 Backup Script.
		* http://www.phpbb.com */
		if ($type == "config") {
			header("Pragma: no-cache");
			$do_gzip_compress = FALSE;
			$gzipcompress = $_POST['gzipcompress-config'];
			if ($gzipcompress ) {
				$phpver = phpversion();
				if ($phpver >= "4.0") {
					if (extension_loaded("zlib")) {
						$do_gzip_compress = TRUE;
					}
				}
			}
			if ($do_gzip_compress) {
				@ob_start();
				@ob_implicit_flush(0);
				header("Content-Type: application/x-gzip; name=\"config.php.gz\"");
				header("Content-disposition: attachment; filename=config.php.gz");
			} else {
				header("Content-Type: text/x-delimtext; name=\"config.php\"");
				header("Content-disposition: attachment; filename=config.php");
			}
			$config = file('config.php');
			foreach($config as $line_num => $line) {
				echo $line;
			}
		} else {
			$timestamp = date("Y-m-d_H-i-s");
			$tables = array('auth', 'comments', 'uploads', 'users', 'journalness', 'links', 'config');
			header("Pragma: no-cache");
			$do_gzip_compress = FALSE;
			$gzipcompress = $_POST['gzipcompress'];
			if ($gzipcompress ) {
				$phpver = phpversion();
				if ($phpver >= "4.0") {
					if (extension_loaded("zlib")) {
						$do_gzip_compress = TRUE;
					}
				}
			}
			if ($do_gzip_compress) {
				@ob_start();
				@ob_implicit_flush(0);
				header("Content-Type: application/x-gzip; name=\"journalness_db_backup.sql.gz\"");
				header("Content-disposition: attachment; filename=journalness_db_backup.sql.gz");
			} else {
				header("Content-Type: text/x-delimtext; name=\"journalness_db_backup.sql\"");
				header("Content-disposition: attachment; filename=journalness_db_backup.sql");
			}
			echo "#\n";
			echo "# Journalness Backup Script\n";
			echo "# Dump of tables for " . DB_NAME . "\n";
			echo "#\n# DATE : " . gmdate("d-m-Y H:i:s", time()) . " GMT\n";
			echo "#\n";
			for($i = 0; $i < count($tables); $i++) {
				$table_name = $tables[$i];
				$backup_type = $_POST['backup_type'];
				if(DBMS == "pgsql"){
					echo "\n" . pg_get_sequences("\n", $backup_type);
				}
				if ($backup_type != 'data') {
					if(DBMS == "mysql"){
						$drop = $_POST['drop'];
						$drop = "1";
						echo "#\n# Table structure for table: " . TABLE_PRE . $table_name . "\n#\n";
						echo get_table_structure(TABLE_PRE . $table_name, "\n", $drop) . "\n";
					}elseif(DBMS == "pgsql"){
						echo "#\n# Table structure for table: " . TABLE_PRE . $table_name . "\n#\n";
						echo get_table_def_postgresql(TABLE_PRE . $table_name, "\n") . "\n";
					}
				}
				if ($backup_type != 'structure') {
					if(DBMS == "mysql"){
						get_table_content(TABLE_PRE . $table_name);
					}elseif(DBMS == "pgsql"){
						echo "\n" . pg_get_sequences("\n", $backup_type);
						get_table_content_postgresql(TABLE_PRE . $table_name, output_table_content);
					}
				}
			}
		}
	} else {
		$smarty->assign(array(
				"show_backup" => "true",
				"L_BACKUP_TITLE" => $lang['Backup_title'],
				"L_FULL_BACKUP" => $lang['Full_backup'],
				"L_STRUCTURE_ONLY" => $lang['Structure_only'],
				"L_DATA_BACKUP" => $lang['Data_backup'],
				"L_GZIP_FILE" => $lang['Gzip_file'],
				"L_NO" => $lang['No'],
				"L_YES" => $lang['Yes'],
				"L_DOWNLOAD_BACKUP" => $lang['Download_backup'],
				"L_CONFIG_BACKUP_TITLE" => $lang['Config_backup_title'],
				"L_DOWNLOAD_CONFIG" => $lang['Download_config'])
		);
		
		// Display Page
		$smarty->display("$def_theme/backup.tpl");
	}
} else {
	$smarty->assign(array(
			"show_not_admin" => "true",
			"L_ERROR" => $lang['Error'],
			"L_NOT_ADMIN" => $lang['Not_admin'])
	);

	// Display Page
	$smarty->display("$def_theme/backup.tpl");
}
// Start Backup Functions List
if ($do_gzip_compress) {
	$Size = ob_get_length();
	$Crc = crc32(ob_get_contents());
	$contents = gzcompress(ob_get_contents());
	ob_end_clean();
	echo "\x1f\x8b\x08\x00\x00\x00\x00\x00".substr($contents, 0, strlen($contents) - 4).gzip_PrintFourChars($Crc).gzip_PrintFourChars($Size);
}
?>
