<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

if (@file_exists('config.php')) {
	require_once('config.php');
}

if (!defined('INSTALLED')) {
	header('Location: install/install.php');
	exit;
}

require_once('./libs/CustomAuthContainer.php');
require_once('./libs/CustomAuth.php');

$path = getcwd();
$path .= "/includes/";
ini_set("include_path", $path . PATH_SEPARATOR . ini_get("include_path"));

require_once 'DB.php';
PEAR::setErrorHandling(PEAR_ERROR_DIE);
$dsn = "".DBMS."://".DB_USERNAME.":".DB_PASSWORD."@";
if(DB_HOST != 'localhost'){
        $dsn .= "".DB_HOST."";
}
$dsn .= "/".DB_NAME."";
$db = DB::connect($dsn);

$sql = "SELECT * FROM " . TABLE_PRE . "config";
$result = $db->query($sql);
while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
	${$row[name]} = $row[value];
}
$result->free();
$sql = "SELECT email, username FROM " . TABLE_PRE . "users WHERE isadmin = '1'";
$result = $db->query($sql);
$admin_info = $result->fetchRow(DB_FETCHMODE_ORDERED);
$result->free();
$admin_email = $admin_info[0];
$admin_name = $admin_info[1];

require_once('functions.inc.php');
require_once('./libs/Smarty.class.php');
require_once(SMARTY_DIR.'Config_File.class.php');

$params = array(
		"dsn" => $dsn,
		"table" => TABLE_PRE . "users",
		"usernamecol" => "username",
		"passwordcol" => "password",
		"cryptType" => $crypt_type
	);

$smarty = new Smarty;
require_once('./language/lang_' . $def_language . '/lang_' . $def_language . '.php');

$anon_com_opt[yes] = $lang['Yes'];
$anon_com_opt[no] = $lang['No'];


$smarty->assign(array(
	"theme" => $def_theme,
	"L_POWERED_BY" => sprintf($lang['Powered_by'], "<a href=\"http://journalness.sourceforge.net\" onclick=\"window.open(this.href); return false;\">", "</a>", $version),
	"L_QUICK_SEARCH" => $lang['Quick_search'],
	"L_SEARCH" => $lang['Search'],
	"JOURNALTYPE" => $journaltype,
	"L_JOURNAL_LINKS" => $lang['Journal_links'],
	"JOURNALTITLE" => $journaltitle)
);

$auth_container = new CustomAuthContainer($params);
$a = new Auth($auth_container,$params,"displayLogin",$journaltype==2?true:false);
if ($_POST["rememberme_cookie"]) {
	$a->setLoginCallback('myLoginCallback');
}
$a->start();

if ($_COOKIE['username'] && !$a->checkAuth()) {
	$a->setAuth($_COOKIE['username']);
}

if($a->checkAuth()){
	$sql = "SELECT def_user_lang,def_user_theme FROM " . TABLE_PRE . "users WHERE username = '" . $a->getUsername() . "'";
	$result = $db->query($sql);
	$def_user_lang = $result->fetchRow(DB_FETCHMODE_ORDERED);
	$def_language = $def_user_lang[0];
	$def_theme = $def_user_lang[1];
	$result->free();
}
require_once('./language/lang_' . $def_language . '/lang_' . $def_language . '.php');

$anon_com_opt[yes] = $lang['Yes'];
$anon_com_opt[no] = $lang['No'];

$smarty->assign(array(
		"theme" => $def_theme,
		"L_POWERED_BY" => sprintf($lang['Powered_by'], "<a href=\"http://journalness.sourceforge.net\" onclick=\"window.open(this.href); return false;\">", "</a>", "" ),
		"L_QUICK_SEARCH" => $lang['Quick_search'],
		"L_SEARCH" => $lang['Search'],
		"JOURNALTYPE" => $journaltype,
		"L_JOURNAL_LINKS" => $lang['Journal_links'],
		"JOURNALTITLE" => $journaltitle)
);


$sql = "SELECT verified, uid FROM " . TABLE_PRE . "users WHERE username = '".$a->getUsername()."'";
$result = $db->query($sql);
$row = $result->fetchRow();

if($row[0] == "0" && $validation == "yes"){
	$a->setLogoutCallback('myLogoutCallback');
	$a->logout();
	$a->start();
	$not_authed = sprintf($lang['Not_authed'], $row[1], $admin_email, $admin_email);
	$smarty = new Smarty;
	$current_username = $a->getUsername();
	$smarty->assign(array(
			"theme" => $def_theme,
			"L_JOURNAL_LINKS" => $lang['Journal_links'],
			"L_LOGIN" => $lang['Login'],
			"L_LOGOUT" => sprintf($lang['Logout'], "$current_username"),
			"L_HOME" => $lang['Home'],
			"L_ALL_ENTRIES" => $lang['All_entries'],
			"L_MY_ENTRIES" => $lang['My_entries'],
			"L_CREATE_ENTRY" => $lang['Create_entry'],
			"L_MY_PROFILE" => $lang['My_profile'],
			"L_MY_CLIP" => $lang['My_clip'],
			"L_MY_PANEL" => $lang['My_panel'],
			"L_ADMIN_PANEL" => $lang['Admin_panel'],
			"L_REGISTER" => $lang['Register'],
			"L_ADMIN_PANEL_LINKS" => $lang['Admin_panel_links'],
			"L_USER_PANEL_LINKS" => $lang['My_panel'],
			"L_EDIT_SIG"=> $lang['Edit_sig'],
			"L_ADD_USER" => $lang['Add_user'],
			"L_USER_ADMIN" => $lang['User_admin'],
			"L_BACKUP" => $lang['Backup'],
			"L_JOURNAL_CONFIG" => $lang['Journal_config'],
			"L_LINKS_ADMIN" => $lang['Links_admin'],
			"L_BLOGGERS" => $lang['Bloggers'],
			"L_POWERED_BY" => sprintf($lang['Powered_by'], "<a href=\"http://journalness.sourceforge.net\" onclick=\"window.open(this.href); return false;\">", "</a>", $version),
			"L_QUICK_SEARCH" => $lang['Quick_search'],
			"L_SEARCH" => $lang['Search'],
			"JOURNALTYPE" => $journaltype,
			"JOURNALTITLE" => $journaltitle));

	$smarty->display("$def_theme/header.tpl");
	$smarty->display("$def_theme/navigation.tpl");
	echo "<div class=\"centered\"><h2>$lang[Error]</h2><br/>
		<p>" . $not_authed . "</p></div></td></tr>";
	exit;
}

$current_username = $a->getUsername();
$smarty->assign(array(
		"theme" => $def_theme,
		"L_JOURNAL_LINKS" => $lang['Journal_links'],
		"L_LOGIN" => $lang['Login'],
		"L_LOGOUT" => sprintf($lang['Logout'], "$current_username"),
		"L_HOME" => $lang['Home'],
		"L_ALL_ENTRIES" => $lang['All_entries'],
		"L_MY_ENTRIES" => $lang['My_entries'],
		"L_CREATE_ENTRY" => $lang['Create_entry'],
		"L_MY_PROFILE" => $lang['My_profile'],
		"L_MY_CLIP" => $lang['My_clip'],
		"L_MY_PANEL" => $lang['My_panel'],
		"L_ADMIN_PANEL" => $lang['Admin_panel'],
		"L_EDIT_SIG" => $lang['Edit_sig'],
		"L_REGISTER" => $lang['Register'],
		"L_ADMIN_PANEL_LINKS" => $lang['Admin_panel_links'],
		"L_USER_PANEL_LINKS" => $lang['My_panel'],
		"L_ADD_USER" => $lang['Add_user'],
		"L_USER_ADMIN" => $lang['User_admin'],
		"L_BACKUP" => $lang['Backup'],
		"L_JOURNAL_CONFIG" => $lang['Journal_config'],
		"L_LINKS_ADMIN" => $lang['Links_admin'],
		"L_BLOGGERS" => $lang['Bloggers']));

$smarty->assign('logged_in', $a->checkAuth());
$smarty->assign('current_username', $current_username);
$smarty->assign('crypt_type', $crypt_type);
$smarty->assign('admin_name', $admin_name);

if ($journaltype == 2 && !$a->checkAuth()) {
	exit;
}

$sql = "SELECT username, uid FROM " . TABLE_PRE . "users WHERE username != 'Anonymous User' ORDER BY username ASC";
$result = $db->query($sql);

if ($result->numRows() > 1 ) {
	while ($user = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
		$bloggers[] = $user;
	}
	$smarty->assign('bloggers', $bloggers);
}
$result->free();

$sql = "SELECT * FROM " . TABLE_PRE . "links WHERE iscategory = '1' AND visible = '1' ORDER BY location ASC";
$result = $db->query($sql);
while($category = $result->fetchRow(DB_FETCHMODE_ASSOC)){
	$sql = "SELECT * FROM " . TABLE_PRE . "links WHERE incategory = '$category[linkid]' AND visible = '1' ORDER BY location ASC";
	$result2 = $db->query($sql);
	if($result2->numRows() > 0){
		$links_array[] = $category;
	}
	while ($link_query = $result2->fetchRow(DB_FETCHMODE_ASSOC)){
		$links_array[] = $link_query;
	}
}
if(count($links_array) > 1){
	$smarty->assign('links_list', $links_array);
}
$result->free();

?>
