DROP TABLE IF EXISTS journalness_auth;
DROP TABLE IF EXISTS journalness_comments;
DROP TABLE IF EXISTS journalness_config;
DROP TABLE IF EXISTS journalness_uploads;
DROP TABLE IF EXISTS journalness_links;
DROP TABLE IF EXISTS journalness_users;
DROP TABLE IF EXISTS journalness_journalness;

CREATE TABLE journalness_comments(
	commentid int(10) NOT NULL auto_increment,
	eid int(10) NOT NULL,
	title varchar(50) NOT NULL,
	commenttime datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
	username varchar(30) NOT NULL,
	comment text NOT NULL,
	ip varchar(64) NOT NULL, 
	PRIMARY KEY (commentid)
);

CREATE TABLE journalness_config(
	name varchar(255) NOT NULL,
	value varchar(255) NOT NULL,
	PRIMARY KEY (name)
);

CREATE TABLE journalness_uploads(
	imageid int(10) NOT NULL auto_increment,
	image LONGTEXT,
	path varchar(255) NOT NULL,
	imagename varchar(255) NOT NULL,
	poster varchar(30), 
	PRIMARY KEY (imageid)
);

CREATE TABLE journalness_links(
	linkid int(8) NOT NULL auto_increment,
	name VARCHAR(255) NOT NULL,
	value VARCHAR(255) NULL,
	iscategory TINYINT UNSIGNED NULL,
	incategory int(8) NULL,
	location int(8) NULL,
	visible TINYINT UNSIGNED NULL,
	PRIMARY KEY (linkid)
);


CREATE TABLE journalness_auth(
	userid TINYINT UNSIGNED NOT NULL,
	authcode VARCHAR(32)
);

CREATE TABLE journalness_users(
	uid int(10) NOT NULL AUTO_INCREMENT,
	username varchar(40),
	password varchar(40),
	email varchar(255) NOT NULL,
	email_public TINYINT(1) UNSIGNED NOT NULL,
	verified TINYINT(1) UNSIGNED NOT NULL,
	isadmin TINYINT(3) UNSIGNED NULL,
	def_user_lang varchar(255) NOT NULL,
	realname varchar(100),
	age int(3) NULL,
	sex varchar(1),
	icq varchar(15),
	aim varchar(255),
	yim varchar(255),
	msn varchar(255),
	website varchar(100),
	location varchar(100),
	clip TEXT,
	sig TEXT,
	def_user_theme varchar(255) NOT NULL,
	PRIMARY KEY(uid),
	UNIQUE KEY email (email)	
);

CREATE TABLE journalness_journalness(
	eid int(10) NOT NULL auto_increment,
	entry_time datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
	entry_title varchar(255),
	entry text,
	poster varchar(30),
	ip varchar(64), 
	PRIMARY KEY (eid)
);
