DROP TABLE journalness_auth;
DROP TABLE journalness_comments;
DROP TABLE journalness_config;
DROP TABLE journalness_journalness;
DROP TABLE journalness_uploads;
DROP TABLE journalness_links;
DROP TABLE journalness_users;

CREATE SEQUENCE journalness_comments_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;
CREATE SEQUENCE journalness_journalness_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;
CREATE SEQUENCE journalness_uploads_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;
CREATE SEQUENCE journalness_users_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;
CREATE SEQUENCE journalness_links_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;

CREATE TABLE journalness_auth (
    userid int4 NOT NULL,
    authcode varchar(32)
);

CREATE TABLE journalness_config (
    name varchar(255) NOT NULL,
    value varchar(255) NOT NULL,
    CONSTRAINT journalness_config_pkey PRIMARY KEY (name)
);

CREATE TABLE journalness_comments (
    commentid int4 DEFAULT nextval('journalness_comments_id_seq'::text) NOT NULL,
    eid int4 NOT NULL,
    title varchar(50) NOT NULL,
    commenttime timestamp without time zone NOT NULL,
    username varchar(30) NOT NULL,
    "comment" text NOT NULL,
    ip varchar(64) NOT NULL,
    CONSTRAINT journalness_comments_pkey PRIMARY KEY (commentid)
);


CREATE TABLE journalness_journalness (
    eid int4 DEFAULT nextval('journalness_journalness_id_seq'::text) NOT NULL,
    entry_time timestamp without time zone NOT NULL,
    entry_title varchar(100) NOT NULL,
    entry text NOT NULL,
    poster varchar(30) NOT NULL,
    ip varchar(64) NOT NULL,
    CONSTRAINT journalness_journalness_pkey PRIMARY KEY (eid)
);

CREATE TABLE journalness_links (
    linkid int4 DEFAULT nextval('journalness_links_id_seq'::text) NOT NULL,
    name varchar(255) NOT NULL,
    value varchar(255) NULL,
    iscategory int2 NULL,
    incategory int4 NULL,
    location int4 NULL,
    visible int4 NULL,
    CONSTRAINT journalness_links_pkey PRIMARY KEY (linkid)
);


CREATE TABLE journalness_uploads (
    imageid int4 DEFAULT nextval('journalness_uploads_id_seq'::text) NOT NULL,
    image text,
    path varchar(255) NOT NULL,
    imagename varchar(255) NOT NULL,
    poster varchar(30),
    CONSTRAINT journalness_uploads_pkey PRIMARY KEY (imageid)
);


CREATE TABLE journalness_users (
    uid int4 DEFAULT nextval('journalness_users_id_seq'::text) NOT NULL,
    username varchar(40) NOT NULL,
    "password" varchar(40) NOT NULL,
    email varchar(255) NOT NULL,
    email_public int2 NOT NULL,
    verified int2 DEFAULT '0' NOT NULL,
    isadmin int2 NULL,
    def_user_lang varchar(255) NOT NULL,
    realname varchar(100),
    age int2,
    sex char(1),
    icq varchar(255),
    aim varchar(255),
    yim varchar(255),
    msn varchar(255),
    website varchar(100),
    "location" varchar(100),
    clip text,
    sig text,
    def_user_theme varchar(255) NOT NULL,
    CONSTRAINT journalness_users_email_key UNIQUE (email),
    CONSTRAINT journalness_users_pkey PRIMARY KEY (uid)
);
