<?php
$path = getcwd();
$path .= "/includes/";
ini_set("include_path", $path . PATH_SEPARATOR . ini_get("include_path"));

include_once('Auth/Auth.php');
class CustomAuth extends Auth {
    /**
     * Constructor
     *
     * Set up the storage driver.
     *
     * @param string    Type of the storage driver
     * @param mixed     Additional options for the storage driver
     *                  (example: if you are using DB as the storage
     *                   driver, you have to pass the dsn string here)
     *
     * @param string    Name of the function that creates the login form
     * @param boolean   Should the login form be displayed if neccessary?
     * @return void
     */
    function CustomAuth($storageDriver, $options = '', $loginFunction = '', $showLogin = true)
    {
		Auth::Auth($storageDriver,$options,$loginFunction,$showLogin);
	}
	
    /**
     * Change password for user in the storage container
     *
     * @access public
     * @param string Username
     * @param string The new password 
     * @return mixed True on success, PEAR error object on error
     *               and AUTH_METHOD_NOT_SUPPORTED otherwise.
     */
    function changePassword($username, $password)
    {
        return $this->storage->changePassword($username, $password);
    }
	
}
?>
