<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

if ($a->getAuthData('registered')) {
	/*
	 * This is the page that will be displayed after the
	 * registration has been attempted.
	 */
	$uname = $a->getAuthData('reguname');
	$uname = stripslashes($uname);
	if ($a->getAuthData('regresult')) {
		$smarty->display("$def_theme/header.tpl");
		if ($a->getUsername() == $admin_name) {
			$smarty->assign('show_admin_links', 'true');
		}
		$smarty->display("$def_theme/navigation.tpl");
		$regsuccessful = sprintf($lang[User_successfully_added], $uname);
		echo "<div class=\"centered\">
			<p>$regsuccessful<br/><br/></p>";
		if($validation == "yes"){
			echo "<p>$lang[Register_validation_email_sent]</p>";
		}
		echo "</div>";
	} else {
		$smarty->display("$def_theme/header.tpl");
		if ($a->getUsername() == $admin_name) {
			$smarty->assign('show_admin_links', 'true');
		}
		$smarty->display("$def_theme/navigation.tpl");
		$regfailed = sprintf($lang[Registration_failed], $uname);
		echo "<div class=\"centered\">
			<h2>$lang[Registration_failed_title]</h2>
			<p>$regfailed</p>
			</div>";
	}
	$a->setAuthData('reguname',false);
	$a->setAuthData('registered',false);
	$a->setAuthData('regresult',false);
	return;
}
/*
 * Determines whether or not to show to sign-up form
 * based on whether the form has been submitted, if it
 * has, check the database for consistency and create
 * the new account.
 */
if (isset($_POST['subjoin'])) {
	$_POST['user'] = addslashes($_POST['user']);
	$invalid_chars = '#<>&';
	$str = $_POST['user'];
	if (strcspn($str, $invalid_chars) != strlen($str)) {
		$smarty->display("$def_theme/header.tpl");
		if ($a->getUsername() == $admin_name) {
			$smarty->assign('show_admin_links', 'true');
		}
		$smarty->display("$def_theme/navigation.tpl");
		echo "<div class=\"centered\"><h2>$lang[Invalid_chars]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
		exit;
	} else {
		/* Make sure all fields were entered */
		if (!$_POST['user'] || !$_POST['pass']) {
			exit;
		}
		/* Check that passwords match */
		if ($_POST['pass'] != $_POST['conf']) {
			exit;
		}
		/* Spruce up username, check length */
		$_POST['user'] = trim($_POST['user']);
		if (strlen($_POST['user']) > 30) {
			$smarty->display("$def_theme/header.tpl");
			if ($a->getUsername() == $admin_name) {
				$smarty->assign('show_admin_links', 'true');
			}
			$smarty->display("$def_theme/navigation.tpl");
			echo "<div class=\"centered\"><h2>$lang[Username_too_long]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
			exit;
		}
		/* Check if username is already in use */
		if (usernameTaken($_POST['user'])) {
			//$use = $_POST['user'];
			$smarty->display("$def_theme/header.tpl");
			if ($a->getUsername() == $admin_name) {
				$smarty->assign('show_admin_links', 'true');
			}
			$smarty->display("$def_theme/navigation.tpl");
			echo "<div class=\"centered\"><h2>$lang[Username_taken]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
			exit;
		}

		/* Check if email is already in use */
		if (emailTaken($_POST['email'])){
			$smarty->display("$def_theme/header.tpl");
			if($a->getUsername() == $admin_name){
				$smarty->assign('show_admin_links', 'true');
			}
			$smarty->display("$def_theme/navigation.tpl");
			echo "<div class=\"centered\"><h2>$lang[Email_taken]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
			exit;
		}

		/* Add the new account to the database */
		if($crypt_type != 'none'){
			$_POST['pass'] .= '7b949c8716';
		}
		switch ($validation){
		case "yes":
			$verified = 0;
			break;
		case "no":
			$verified = 1;
			break;
		default:
			$verified = 0;
		}

		$_POST['user'] = htmlspecialchars($_POST['user']);
		$_POST['email'] = htmlspecialchars($_POST['email']);
		$_POST['realname'] = htmlspecialchars($_POST['realname']);
		$_POST['icq'] = htmlspecialchars($_POST['icq']);
		$_POST['aim'] = htmlspecialchars($_POST['aim']);
		$_POST['yim'] = htmlspecialchars($_POST['yim']);
		$_POST['msn'] = htmlspecialchars($_POST['msn']);
		$_POST['website'] = htmlspecialchars($_POST['website']);
		$_POST['location'] = htmlspecialchars($_POST['location']);

		$a->setAuthData('regresult',$a->addUser($_POST['user'],$_POST['pass'],array('email' => $_POST['email'], 'email_public' => $_POST['email_public'],
															'def_user_lang' => $_POST['def_user_lang'], 'verified' => $verified, 'def_user_theme' => $_POST['def_user_theme'],
															'realname' => $_POST['realname'], 'sex' => $_POST['sex'],
															'icq' => $_POST['icq'], 'aim' => $_POST['aim'], 
															'yim' => $_POST['yim'], 'msn' => $_POST['msn'], 
															'website' => $_POST['website'], 'location' => $_POST['location'])));
		if($_POST[age] == "nothing" || $_POST[age] == "0" || $_POST[age] == ""){
			$sql = "UPDATE " . TABLE_PRE . "users SET age = NULL WHERE username = '$_POST[user]'";
			$db->query($sql);
			}else{
			$sql = "UPDATE " . TABLE_PRE . "users SET age = '$_POST[age]' WHERE username = '$_POST[user]'";
			$db->query($sql);
		}
		$a->setAuthData('reguname',$_POST['user']);
		$a->setAuthData('registered',true);
/*		if($validation == "yes"){
			sendAuthEmail($_POST['user']);
		}
*/
		header('Location: register.php');
		
		if($validation == "yes"){
		
			sendAuthEmail($_POST['user']);

		}
		exit;
	}
} elseif (isset($_POST['admin_add'])){

	$_POST['username'] = addslashes($_POST['username']);
	$invalid_chars = '<>';
	$str = $_POST['username'];
	if (strcspn($str, $invalid_chars) != strlen($str)) {
		$smarty->display("$def_theme/header.tpl");
		if ($a->getUsername() == $admin_name) {
			$smarty->assign('show_admin_links', 'true');
		}
		$smarty->display("$def_theme/navigation.tpl");
		echo "<div class=\"centered\"><h2>$lang[Invalid_chars]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
		exit;
	} else {
		/* Make sure all fields were entered */
		if ($_POST['verified'] == "0" || $_POST['verified'] == "1"){
			$verified_checked = "Yes";
		}
		if (!$_POST['username'] || !$_POST['password'] || !$_POST['password_conf'] || !$_POST['email'] || !$verified_checked) {
			exit;
		}
		/* Check that passwords match */
		if ($_POST['password'] != $_POST['password_conf']) {
			exit;
		}
		/* Spruce up username, check length */
		$_POST['username'] = trim($_POST['username']);
		if (strlen($_POST['username']) > 30) {
			$smarty->display("$def_theme/header.tpl");
			if ($a->getUsername() == $admin_name) {
				$smarty->assign('show_admin_links', 'true');
			}
			$smarty->display("$def_theme/navigation.tpl");
			echo "<div class=\"centered\"><h2>$lang[Username_too_long]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
			exit;
		}
		/* Check if username is already in use */
		if (usernameTaken($_POST['username'])) {
			$smarty->display("$def_theme/header.tpl");
			if ($a->getUsername() == $admin_name) {
				$smarty->assign('show_admin_links', 'true');
			}
			$smarty->display("$def_theme/navigation.tpl");
			echo "<div class=\"centered\"><h2>$lang[Username_taken]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
			exit;
		}

		/* Check if email is already in use */
		if (emailTaken($_POST['email'])){
			$smarty->display("$def_theme/header.tpl");
			if($a->getUsername() == $admin_name){
				$smarty->assign('show_admin_links', 'true');
			}
			$smarty->display("$def_theme/navigation.tpl");
			echo "<div class=\"centered\"><h2>$lang[Email_taken]</h2><br/><a href=\"./register.php\">$lang[Go_back]</a></div></td></tr>";
			exit;
		}

		/* Add the new account to the database */
		if($crypt_type != 'none'){
			$_POST['password'] .= '7b949c8716';
		}

		$verified = $_POST['verified'];
		$_POST['username'] = htmlspecialchars($_POST['username']);
		$_POST['email'] = htmlspecialchars($_POST['email']);
		$_POST['realname'] = htmlspecialchars($_POST['realname']);
		$_POST['icq'] = htmlspecialchars($_POST['icq']);
		$_POST['aim'] = htmlspecialchars($_POST['aim']);
		$_POST['yim'] = htmlspecialchars($_POST['yim']);
		$_POST['msn'] = htmlspecialchars($_POST['msn']);
		$_POST['website'] = htmlspecialchars($_POST['website']);
		$_POST['location'] = htmlspecialchars($_POST['location']);

		$a->setAuthData('regresult',$a->addUser($_POST['username'],$_POST['password'],array('email' => $_POST['email'], 'email_public' => $_POST['email_public'],
															'def_user_lang' => $_POST['def_user_lang'], 'verified' => $verified, 'def_user_theme' => $def_theme,
															'realname' => $_POST['realname'], 'sex' => $_POST['sex'],
															'icq' => $_POST['icq'], 'aim' => $_POST['aim'], 
															'yim' => $_POST['yim'], 'msn' => $_POST['msn'], 
															'website' => $_POST['website'], 'location' => $_POST['location'])));
		if($_POST['age'] != ""){
			$sql = "UPDATE " . TABLE_PRE . "users SET age = '$_POST[age]'";
			$db->query($sql);
		}
		$a->setAuthData('reguname',$_POST['username']);
		$a->setAuthData('registered',true);

		header('Location: register.php');
		exit;
	}

} else {
	/*
	 * This is the page with the sign-up form, the names
	 * of the input fields are important and should not
	 * be changed.
	 */

	if ($a->getUsername() == $admin_name || $journaltype == 0) {
		if ($a->getUsername() == $admin_name) {
			$smarty->assign('show_admin_links', 'true');
		}
		$smarty->assign(array(
				"show_register" => "true",
				"L_REGISTER" => $lang['Register'],
				"L_REGISTRATION_INFORMATION" => $lang['Registration_information'],
				"L_REQUIRED_FIELDS" => $lang['Required_fields'],
				"L_PROFILE_USERNAME" => $lang['Profile_username'],
				"L_PROFILE_EMAIL" => $lang['Profile_email'],
				"L_EMAIL_VIEWABLE" => $lang['Email_viewable'],
				"L_YES" => $lang['Yes'],
				"L_NO" => $lang['No'],
				"L_REGISTRATION_PASSWORD" => $lang['Registration_password'],
				"L_CONFIRM_REGISTRATION_PASSWORD" => $lang['Confirm_registration_password'],
				"L_PROFILE_INFORMATION" => $lang['Profile_information'],
				"L_USER_LANGUAGE" => $lang['User_language'],
				"L_USER_THEME" => $lang['User_theme'],
				"theme_options" => $themes,
				"cust_options" => $languages,
				"def_lang" => $def_language,
				"def_theme" => $def_theme,
				"L_REAL_NAME" => $lang['Real_name'],
				"L_AGE" => $lang['Age'],
				"L_SEX" => $lang['Sex'],
				"L_MALE" => $lang['Male'],
				"L_FEMALE" => $lang['Female'],
				"L_ICQ" => $lang['ICQ'],
				"L_AIM" => $lang['AIM'],
				"L_YIM" => $lang['YIM'],
				"L_MSN" => $lang['MSN'],
				"L_WEBSITE" => $lang['Website'],
				"L_WEB_EXAMPLE" => $lang['Web_example'],
				"L_LOCATION" => $lang['Location'],
				"L_PLAINTEXT_WARNING" => $lang['Plaintext_warning'])
		);
		$smarty->assign('crypt_type', $crypt_type);
	} else {
		$smarty->assign(array(
				"show_not_admin" => "true",
				"L_ERROR" => $lang['Error'],
				"L_NOT_ADMIN" => $lang['Not_admin'],
				"L_LOGIN_LINK" => $lang['Login_link'])
		);
	}
}
$smarty->display("$def_theme/register.tpl");


?>
